#ifndef _Conn_h
#define _Conn_h 1

#include <unistd.h>
#include <stdio.h>

#include <Conn_com.h>

/* Variables */
extern void		(*Conn_accept_cb)(Conn *C);
extern void		(*Conn_recv_cb)(Conn *C);
extern void		(*Conn_send_cb)(Conn *C);
extern unsigned int	(*Conn_data_cb)(Conn *C);
extern void		(*Conn_close_cb)(Conn *C);
extern void		(*Conn_trigger_cb)(Conn *C);
extern void		(*Conn_error_cb)(Conn *C);
extern void		(*Conn_connected_cb)(Conn *C);
extern char		*(*Conn_status_slot_html_cb)(Conn *C);
extern char		*(*Conn_status_cb)(void);

extern unsigned int	Conn_max_reached;
extern unsigned int	Conn_default_ibuf;
extern unsigned int	Conn_default_obuf;
extern unsigned int	Conn_max_ibuf;
extern unsigned int	Conn_max_obuf;
extern unsigned int	Conn_no;
extern unsigned int	Conn_max;
extern unsigned long	Conn_total;
extern unsigned int	Conn_start;
extern unsigned int	Conn_pending;
extern struct timeval	Conn_now;

extern unsigned int	Conn_max_send;
extern unsigned int	Conn_max_recv;

extern unsigned short	Conn_level;


/* Functions */
extern char		*Conn_strerror(void);
extern int		Conn_init(unsigned int max);
extern void		Conn_close(Conn *C);
extern ssize_t		Conn_send(Conn *C, void *buf, size_t count);
extern ssize_t		Conn_recv(Conn *C, void *buf, size_t count);
extern Conn		*Conn_socket(int domain, int type, int port);
extern char		*Conn_status(unsigned int flags);
extern int		Conn_poll(int timeout);
extern int		Conn_enqueue(Conn *C, void *buf, size_t count);
extern void		Conn_debug(FILE *f, unsigned short debug);
extern Conn		*Conn_connect(int domain, int type, char *addr, int port);
extern char		*Conn_dump(char *buf_src, int len_src);
extern char		*Conn_dumphex(char *buf_src, int len_src);
extern int		Conn_nodelay(Conn *C);
extern void		Conn_rollback(Conn *C, unsigned int bytes);
extern char		*Conn_strstr(Conn *C, char *str);
extern unsigned int	Conn_qlen(Conn *C);
extern void		Conn_eat(Conn *C, unsigned int bytes);
extern void		Conn_eatall(Conn *C);
extern char		*Conn_ibuf(Conn *C);
extern char		*Conn_obuf(Conn *C);
extern int		Conn_try_expand_buf(Conn *C, int what, int needed);
extern int		Conn_band(Conn *C, unsigned int width, unsigned int factor);
extern void		Conn_set(Conn *C, int var, unsigned int val);
extern char		*Conn_ostrstr(Conn *C, unsigned int off, char *str);
extern unsigned long long	Conn_getid(Conn *C);
extern Conn		*Conn_get(unsigned long long id);

#endif
